#include "struttura.h"
#include <iostream>

using namespace std;
/*Funzione di input: la funzione 
 * prende come argomento l'array allocato dinamicamente
 *nel main e con il ciclo permette all'utente di inserire
 *tutte le prenotazioni.
 **/
void input(Prenotazione *p, int dim) {
    for (int i = 0; i < dim; i++) {
        cout << "Inserire codice volo: ";
        cin >> p->volo;
        cin.ignore();
        cout << "Inserire nome passeggero: ";
        cin.getline(p->nome,16);
        cout << "Inserire cognome passeggero: ";
        cin.getline(p->cognome,16);
        cout << "Inserire codice prenotazione: ";
        cin >> (p++)->pren;
        cout << "-----------------------------------" << endl;
    }
}
   
/*Funzione di stampa: la funzione 
 * prende come argomento l'array allocato dinamicamente
 * nel main e con il ciclo stampa i dati necessari.
 */
void stampa(Prenotazione *p,int dim){
    for (int i=0;i<dim;i++){
        cout<<"Codice volo: "<<p->volo<<endl;
        cout<<"Iniziali cliente: "<<p->nome[0]<<". "<<p->cognome[0]<<". "<<endl;
        cout<<"Prenotazione numero: "<<(p++)->pren<<endl;
        cout<<"-----------------------------"<<endl;
    }
}

/* Funzione di scambio. Funzione necessaria allo scambio di due valori
 *entrambi di tipo struttura Prenotazione.
 */
void swapstru(Prenotazione &a, Prenotazione &b){
    Prenotazione aus;
    aus=a;
    a=b;
    b=aus;
}

/*Funzione di ordinamento.
 *Ogni ciclo della i effettua una scansione dall'alto verso il basso 
 *e dal basso verso l'alto per diminuire i tempi di esecuzione.
 */
void sort(Prenotazione *p, int dim){
    bool scambiato=true;
    for (int i=0;i<(dim-1) && scambiato;i++){
        scambiato=false;
        for (int j=0;j<(dim-i-1);j++){
            if ((p+j)->pren > (p+j+1)->pren){
                swapstru(*(p+j),*(p+j+1));
                scambiato=true;
            }            
        }
        for (int j=dim-1;j>i+1;j--){
            if((p+j)->pren < (p+j-1)->pren){
                swapstru(*(p+j),*(p+j-1));
                scambiato=true;
            }
        }
    }
}

/*Funzione di copia array di strutture. Funzione generica che
 *permette di copiare due array di strutture definendo un punto
 *d'inizio per la copia ed un punto di fine per la copia (start,fin)
 */
void copyarr(Prenotazione *p, Prenotazione *p2, int start, int fin){
    p = p+start;
    for (int i=start;i<fin;i++){
        *(p2++)= *(p++);
    }
}





