

/*

Prova n. 1 del 7/1/2010

Si scriva un programma che definisca e utilizzi la struttura dati più adatta per gestire un elenco di prenotazioni gestito da una compagnia aerea in cui il generico elemento deve contenere le seguenti informazioni:
	identificativo del volo	(es. AZ295)
	cognome del cliente
	nome del cliente
       	codice di prenotazione (valore di tipo intero) 

Il programma deve prevedere inizialmente la lettura dell'elenco con tutti i dati per un numero N di clienti specificato dall'utente. Al termine della lettura, il programma deve prevedere la lettura di due valori K1 e K2 sempre specificati dall'utente e formare due nuovi elenchi: il primo contenente le prime K1 prenotazioni in ordine di codice ed il secondo contenente le ultime K2. Il programma deve infine stampare i due elenchi ottenuti, fornendo in output le iniziali del cliente, l'identificativo del volo e il codice di prenotazione.

Costituisce elemento di valutazione positiva la progettazione modulare del programma, l'utilizzo di tecniche per l'allocazione dinamica dela memoria, il commento opportunamente dettagliato del codice, la realizzazione di I/O adeguato.

*/



#include <cstdlib>
#include <iostream>
#include "struttura.h"
#include "funzioni.h"

using namespace std;

int main(int argc, char** argv) {
    
    //Inizializzo i puntatori che ospiteranno gli indrizzi dei tre array
    Prenotazione *pren=NULL,*primpren=NULL,*lastpren=NULL;
    int dim,k1,k2;
    
    cout<<"Benvenuto nel programma di gestione prenotazioni volo\n";
    cout<<"Inserire il numero di prenotazioni da catalogare:";
    cin>>dim;
    
    //Alloco dinamicamente l'array iniziale e controllo che vi sia
    //sufficiente spazio in memoria
    pren = new Prenotazione[dim];
    if (pren==NULL){
        cout<<"Impossibile allocare memoria sufficiente."<<endl;
        return(-1);
    }
    
    //Chiamo le funzioni di input e di ordinamento.
    input(pren,dim);
    sort(pren,dim);
    cout<<endl<<"Inserire il numero di prime prenotazioni da visualizzare: ";
    cin>>k1;
    
    //Alloco dinamicamente l'array delle prime prenotazioni di dimensione k1 
    //e controllo che vi sia sufficiente spazio in memoria.
    primpren = new Prenotazione[k1];
       if (primpren==NULL){
        cout<<"Impossibile allocare memoria sufficiente."<<endl;
        return(-1);
    }
    
    //Copio i primi k1 elemeti dall'array iniziale all'array delle prime
    //prenotazioni e stampo quest'ultimo
    copyarr(pren,primpren,0,k1);
    stampa(primpren,k1);
    
    //Alloco dinamicamente l'array delle ultime prenotazioni di dimensione k2 
    //e controllo che vi sia sufficiente spazio in memoria.
    cout<<endl<<"Inserire il numero di ultime prenotazioni da visualizzare: ";
    cin>>k2;
    lastpren = new Prenotazione[k2];
       if (lastpren==NULL){
        cout<<"Impossibile allocare memoria sufficiente."<<endl;
        return(-1);
    }
    
    //Copio gli ultimi k2 elemeti dall'array iniziale all'array delle ultime
    //prenotazioni e stampo quest'ultimo
    
    copyarr(pren,lastpren,dim-k2,dim);
    stampa(lastpren,k2);
    //Elimino la memoria allocata dinamicamente ed azzero i puntatori.
    delete [] pren;
    delete [] lastpren;
    delete [] primpren;
    pren = NULL;
    lastpren = NULL;
    primpren = NULL;
    return (0);
}

